
	      .SYMBOLS
	      ORG	8000H
	      EXTERN	ERROR_SW
	      EXTERN	H,C,R
	      EXTERN	RH,RC,RR
	      EXTERN	FormatC,FormatH,FormatR
	      EXTERN	Motor_On,Motor_Off
	      EXTERN	Reset,Specify,Select_Data_Rate,Recalibrate,Seek
	      EXTERN	Read,Write,Format_Track
;-------------------------------------------------------------------------------
	      INCLUDE	C:\UM6576\Config.inc

	      INCLUDE	COLOR.INC
	      INCLUDE	DATA2.INC

;-------------------------------------------------------------------------------
KUP	      EQU	10H
KDOWN	      EQU	20H
KLEFT	      EQU	40H
KRIGHT	      EQU	80H
KA	      EQU	01H
KB	      EQU	02H
KSTART	      EQU	08H
KSELECT	      EQU	04H
;-------------------------------------------------------------------------------
DIO01	      EQU	300H
DIO02	      EQU	308H
;-------------------------------------------------------------------------------
DEST_ADD      EQU	000H ;W
SOUR_ADD      EQU	002H ;W
RDEST_ADD     EQU	004H ;W
REG_ADD	      EQU	006H ;W
CON	      EQU	008H ;W
BLANK_SW      EQU	00AH ;B
BGX	      EQU	00BH ;B
BGY	      EQU	00CH ;B
RBGX	      EQU	00DH ;B
WRBGSW	      EQU	00EH ;B
BANK_ADD      EQU	00FH ;B
BANK_SW	      EQU	010H ;B
MUSIC_SW      EQU	011H ;B

DIONUM	      EQU	012H ;B
SNP	      EQU	013H ;B
DIO_X	      EQU	014H ;B
DIO_Y	      EQU	015H ;B
SNP_ADD	      EQU	016H ;W
DIO_ADD	      EQU	018H ;W
DIOLOOP	      EQU	01AH ;B
SHOWDIO_SW    EQU	01BH ;B
WRSPSW	      EQU	01CH ;B
CHDIO_CON     EQU	01DH ;B
CHDIO_SW      EQU	01EH ;B
DIOTOTO	      EQU	01FH ;B
DIOBANK_SW    EQU	020H ;B

VDEST_ADD     EQU	030H ;W
VSOUR_ADD     EQU	032H ;W
VCON	      EQU	034H ;W
VBANK_ADD     EQU	036H ;B
VBANK_SW      EQU	037H ;B

KEY1_0	      EQU	040H ;B
KEY1_1	      EQU	041H ;B
KEY1_2	      EQU	042H ;B
KEY2_0	      EQU	043H ;B
KEY2_1	      EQU	044H ;B
KEY2_2	      EQU	045H ;B
ROLTIME	      EQU	046H ;B

BANK_G	      EQU	047H ;B
BANK_M	      EQU	048H ;B
BAX	      EQU	049H
BAY	      EQU	04AH

UNITNO	      EQU	04BH ;B
UNITSW	      EQU	04CH ;B

INT_SW	      EQU	04DH ;B


FORMAT_SW     EQU	050H ;B
READ_SW	      EQU	051H ;B
WRITE_SW      EQU	052H ;B

CURON	      EQU	060H ;B
CURSW	      EQU	061H ;B
CURCON	      EQU	062H ;B
CURPOSI	      EQU	063H ;B
NUM	      EQU	064H ;B
HILO	      EQU	065H ;B
NUMADD	      EQU	066H ;W

DISP_ADD      EQU	06CH ;W
SCR_ADD	      EQU	06EH ;W
DISP_SW	      EQU	070H ;B

WAIT_0	      EQU	080H ;B
WAIT_1	      EQU	081H ;B


SPRITE	      EQU	300H
DIOBUFFER     EQU	500H

;-------------------------------------------------------------------------------
BEGIN

	      SEI
	      CLD
	      LDX	#$FFH
	      TXS
	      LDX	#02H

SET1
	      BIT	$2002
	      BPL	SET1
SET2
	      BIT	$2002
	      BMI	SET2

	      DEX
	      BNE	SET1



	      LDA	#65H
	      LDX	#76H
	      STA	$4031
	      STX	$4031

	      LDA	#FFH
	      STA	$4032


	      LDA	#00H
	      STA	$2000

	      LDA	#02H
	      STA	$2001

	      LDA	#00H		    ;SET BACKGROUND TO 0,0
	      STA	$2005
	      STA	$2005

	      LDA	#81H
	      STA	$2008


	      JSR	CLS_R
	      JSR	CLS_COL
	      JSR	CLS_VR
	      JSR	CLS_DIO
;-------------------------------------------------------------------------------


	      LDA	#80H
	      STA	$2000
	      LDA	#1EH
	      STA	$2001H
	      CLI
	      SEI

	      LDA	#01H
	      STA	UNITSW
	      LDA	#01H
	      STA	UNITNO



	      JSR	INIT8661
TESTADD
	      JSR	TESTDISK

	      JMP	START
;-------------------------------------------------------------------------------
INIT8661
	      LDA	#00H
	      STA	$4026

RRESET
	      ;----------------------
	      ;RESET 8661
	      ;----------------------
	      LDA	$4026
	      ORA	#04H
	      STA	$4026
	      LDA	$4026
	      AND	#FBH
	      STA	$4026


	      LDA	#86H
	      STA	$4279
	      LDA	#61H
	      STA	$4279
	      LDA	#55H
	      STA	$4279
	      LDA	#55H
	      STA	$4279


	      LDA	#6AH
	      STA	$43F0
	      LDA	#B5H
	      STA	$43F0
	      LDA	#DAH
	      STA	$43F0
	      LDA	#EDH
	      STA	$43F0
	      LDA	#F6H
	      STA	$43F0
	      LDA	#FBH
	      STA	$43F0
	      LDA	#7DH
	      STA	$43F0
	      LDA	#BEH
	      STA	$43F0

	      LDA	#DFH
	      STA	$43F0
	      LDA	#6FH
	      STA	$43F0
	      LDA	#37H
	      STA	$43F0
	      LDA	#1BH
	      STA	$43F0
	      LDA	#0DH
	      STA	$43F0
	      LDA	#86H
	      STA	$43F0
	      LDA	#C3H
	      STA	$43F0
	      LDA	#61H
	      STA	$43F0

	      LDA	#B0H
	      STA	$43F0
	      LDA	#58H
	      STA	$43F0
	      LDA	#2CH
	      STA	$43F0
	      LDA	#16H
	      STA	$43F0
	      LDA	#8BH
	      STA	$43F0
	      LDA	#45H
	      STA	$43F0
	      LDA	#A2H
	      STA	$43F0
	      LDA	#D1H
	      STA	$43F0

	      LDA	#E8H
	      STA	$43F0
	      LDA	#74H
	      STA	$43F0
	      LDA	#3AH
	      STA	$43F0
	      LDA	#9DH
	      STA	$43F0
	      LDA	#CEH
	      STA	$43F0
	      LDA	#E7H
	      STA	$43F0
	      LDA	#73H
	      STA	$43F0
	      LDA	#39H
	      STA	$43F0

	      ;----------------------
	      ;LDN[ALL]	 CLOCK
	      ;----------------------
	      LDA	#24H
	      STA	$43F0
	      LDA	#02H
	      STA	$43F1
	      ;----------------------
	      ;LDN[0]  FDC
	      ;----------------------
	      LDA	#07H
	      STA	$43F0
	      LDA	#00H
	      STA	$43F1
	      ;----------------------
	      ;FDC ACTIVE
	      ;----------------------
	      LDA	#30H
	      STA	$43F0
	      LDA	#01H
	      STA	$43F1



	      RTS
;-------------------------------------------------------------------------------
TESTDISK
	      LDA	#00H
	      STA	FORMAT_SW
	      STA	READ_SW
	      STA	WRITE_SW
	      LDA	#00H
	      STA	H
	      STA	C
	      LDA	#01H
	      STA	R


	      JSR	Reset
	      JSR	Specify
	      JSR	Select_Data_Rate
	      JSR	Motor_On
	      JSR	Recalibrate
	      LDA	#00H
	      STA	H
	      LDA	#4FH
	      STA	C
	      JSR	Seek
	      JSR	Recalibrate
	      JSR	Motor_Off
	      LDA	#00H
	      STA	H
	      STA	C
	      LDA	#01H
	      STA	R

	      RTS
;-------------------------------------------------------------------------------

START

	      JSR	WAITBLANKING

	      JSR	READKEY

	      JSR	CHUNIT

	      JSR	LOOP

	      JSR	SETDIO

	      JMP	START
;-------------------------------------------------------------------------------
LOOP
	      LDA	UNITNO
	      CMP	#01H
	      BNE	LOOP_1
	      LDA	ERROR_SW
	      CMP	#01H
	      BNE	?ERROR
	      JSR	PROCERROR
?ERROR
	      JSR	MOVE
	      JSR	ENDC
	      JSR	PROCESSC
	      JSR	CUR
	      JSR	PROCCUR
	      JSR	PROCH_H
	      JSR	PROCH_L
	      JSR	PROCC_H
	      JSR	PROCC_L
	      JSR	PROCR_H
	      JSR	PROCR_L
	      JSR	PROCESSF
	      JSR	PROCESSR
	      JSR	PROCESSW
	      JMP	LOOP_E
LOOP_1
	      LDA	UNITNO
	      CMP	#02H
	      BNE	LOOP_2
	      JMP	LOOP_E
LOOP_2
	      LDA	UNITNO
	      CMP	#03H
	      BNE	LOOP_3
	      JMP	LOOP_E
LOOP_3

LOOP_E
	      RTS
;-------------------------------------------------------------------------------
CHUNIT
	      LDA	UNITSW
	      CMP	#01H
	      BNE	CHUNIT_E

	      LDA	UNITNO
	      CMP	#01H
	      BNE	CHUNIT_1
	      JSR	CHUNIT1
CHUNIT_1
	      LDA	UNITNO
	      CMP	#02H
	      BNE	CHUNIT_2
CHUNIT_2
	      LDA	UNITNO
	      CMP	#03H
	      BNE	CHUNIT_3
CHUNIT_3

	      LDA	#00H
	      STA	UNITSW
CHUNIT_E
	      RTS
;-------------------------------------------------------------------------------
CHUNIT1
	      LDA	#00H
	      STA	$2001

	      JSR	CLS_DIO

	      LDA	#<COLOR0
	      STA	SOUR_ADD
	      LDA	#>COLOR0
	      STA	SOUR_ADD+1

	      JSR	SETCOLORTAB	    ;WRITE PALETTE

	      LDA	#02H
	      STA	DMASourceBank
	      LDA	#<BACODE
	      STA	DMASourceL
	      LDA	#>BACODE
	      STA	DMASourceH
	      LDA	#00H
	      STA	DMADestinationL
	      LDA	#80H
	      STA	DMADestinationH

	      LDA	#FFH
	      STA	DMALengthL
	      LDA	#77H
	      STA	DMALengthH

	      LDA	#11000000b
	      STA	DMAControl



	      LDA	#10H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<SCREEN
	      STA	SOUR_ADD
	      LDA	#>SCREEN
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#00H
	      STA	DEST_ADD
	      LDA	#10H
	      STA	DEST_ADD+1

	      LDA	#32
	      STA	BGX
	      LDA	#30
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT


	      LDA	#00H
	      STA	DMASourceL
	      LDA	#50H
	      STA	DMASourceH
	      LDA	#00H
	      STA	DMADestinationL
	      LDA	#20H
	      STA	DMADestinationH

	      LDA	#7FH
	      STA	DMALengthL
	      LDA	#07H
	      STA	DMALengthH

	      LDA	#11000000b
	      STA	DMAControl


	      LDA	#00H		    ;SET BACKGROUND TO 0,0
	      STA	$2005
	      STA	$2005
	      STA	BAX
	      STA	BAY

	      JSR	WAITBLANKING
	      JSR	WAITBLANKING
	      JSR	WAITBLANKING
	      JSR	WAITBLANKING
	      JSR	WAITBLANKING

	      LDA	#02H
	      STA	DMASourceBank
	      LDA	#<_DIO_pat
	      STA	DMASourceL
	      LDA	#>_DIO_pat
	      STA	DMASourceH
	      LDA	#00H
	      STA	DMADestinationL
	      LDA	#00H
	      STA	DMADestinationH

	      LDA	#3FH
	      STA	DMALengthL
	      LDA	#00H
	      STA	DMALengthH

	      LDA	#11000000b
	      STA	DMAControl

	      LDA	#01H
	      STA	DIO01
	      LDA	#00H
	      STA	DIO01+1H
	      LDA	#80H
	      STA	DIO01+2H
	      LDA	#28H
	      STA	DIO01+3H
	      LDA	#<_DIO_snp
	      STA	DIO01+4H
	      LDA	#>_DIO_snp
	      STA	DIO01+5H
	      LDA	#10H
	      STA	DIO01+6H

	      LDA	#00H
	      STA	DIO02
	      LDA	#01H
	      STA	DIO02+1H
	      LDA	#B8H
	      STA	DIO02+2H
	      LDA	#28H
	      STA	DIO02+3H
	      LDA	#<_DIO_snp
	      STA	DIO02+4H
	      LDA	#>_DIO_snp
	      STA	DIO02+5H
	      LDA	#10H
	      STA	DIO02+6H

	      LDA	#1EH
	      STA	$2001H



	      LDA	#FFH
	      STA	SetTimerValue
	      LDA	#11101111B
	      STA	SystemTimerControl

	      RTS
;-------------------------------------------------------------------------------
MOVE

	      LDA	CURON
	      CMP	#01H
	      BEQ	?MOVE_E
	      LDA	#KUP
	      BIT	KEY1_0
	      BEQ	?MOVE_011
	      JMP	?MOVE_0111
?MOVE_011
	      BIT	KEY2_0
	      BEQ	?MOVE_01
?MOVE_0111
	      DEC	DIO01+3
?MOVE_01
	      LDA	#KDOWN
	      BIT	KEY1_0
	      BEQ	?MOVE_022
	      JMP	?MOVE_0222
?MOVE_022
	      BIT	KEY2_0
	      BEQ	?MOVE_02
?MOVE_0222
	      INC	DIO01+3
?MOVE_02
	      LDA	#KLEFT
	      BIT	KEY1_0
	      BEQ	?MOVE_033
	      JMP	?MOVE_0333
?MOVE_033
	      BIT	KEY2_0
	      BEQ	?MOVE_03
?MOVE_0333
	      DEC	DIO01+2
?MOVE_03
	      LDA	#KRIGHT
	      BIT	KEY1_0
	      BEQ	?MOVE_044
	      JMP	?MOVE_0444
?MOVE_044
	      BIT	KEY2_0
	      BEQ	?MOVE_04
?MOVE_0444
	      INC	DIO01+2
?MOVE_04
	      LDA	#KB
	      BIT	KEY1_1
	      BEQ	?MOVE_077
	      JMP	?MOVE_0777
?MOVE_077
	      BIT	KEY2_1
	      BEQ	?MOVE_07
?MOVE_0777
	      LDA	DISP_SW
	      CMP	#00H
	      BNE	?MOVE_0701
	      JSR	DISPLAY0
	      JMP	?MOVE_07
?MOVE_0701
	      LDA	DISP_SW
	      CMP	#01H
	      BNE	?MOVE_07
	      JSR	DISPLAY1
?MOVE_07
?MOVE_E
	      RTS
;-------------------------------------------------------------------------------
CUR
	      LDA	CURON
	      CMP	#01H
	      BNE	?CUR_E
	      DEC	CURCON
	      BNE	?CUR_E
	      LDA	#10H
	      STA	CURCON

	      LDA	CURSW
	      CMP	#00H
	      BNE	?CUR_01
	      LDA	#01H
	      STA	CURSW
	      LDA	#01H
	      STA	DIO02

	      JMP	?CUR_02
?CUR_01
	      LDA	CURSW
	      CMP	#01H
	      BNE	?CUR_02
	      LDA	#00H
	      STA	CURSW
	      LDA	#00H
	      STA	DIO02

?CUR_02

?CUR_E
	      RTS
;-------------------------------------------------------------------------------
PROCCUR
	      LDA	CURON
	      CMP	#01H
	      BNE	?PROCCUR_T1
	      LDA	#KLEFT
	      BIT	KEY1_1
	      BEQ	?PROCCUR_S1
	      JMP	?PROCCUR_S11
?PROCCUR_S1
	      BIT	KEY2_1
	      BEQ	?PROCCUR_01
?PROCCUR_S11
	      LDA	CURPOSI
	      CMP	#00H
	      BEQ	?PROCCUR_01
	      DEC	CURPOSI
	      LDA	CURPOSI
	      CMP	#03H
	      BNE	?PROCCUR_011
	      LDA	DIO02+2
	      SEC
	      SBC	#10H
	      STA	DIO02+2
	      JMP	?PROCCUR_01
?PROCCUR_011
	      CMP	#01H
	      BNE	?PROCCUR_012
	      LDA	DIO02+2
	      SEC
	      SBC	#10H
	      STA	DIO02+2
	      JMP	?PROCCUR_01
?PROCCUR_012
	      LDA	DIO02+2
	      SEC
	      SBC	#08H
	      STA	DIO02+2
?PROCCUR_01
	      JMP	?PROCCUR_T11
?PROCCUR_T1
	      JMP	?PROCCUR_E
?PROCCUR_T11
	      LDA	#KRIGHT
	      BIT	KEY1_1
	      BEQ	?PROCCUR_S2
	      JMP	?PROCCUR_S22
?PROCCUR_S2
	      BIT	KEY2_1
	      BEQ	?PROCCUR_02
?PROCCUR_S22
	      LDA	CURPOSI
	      CMP	#05H
	      BEQ	?PROCCUR_02
	      INC	CURPOSI
	      LDA	CURPOSI
	      CMP	#02H
	      BNE	?PROCCUR_021
	      LDA	#10H
	      CLC
	      ADC	DIO02+2
	      STA	DIO02+2
	      JMP	?PROCCUR_02
?PROCCUR_021
	      CMP	#04H
	      BNE	?PROCCUR_022
	      LDA	#10H
	      CLC
	      ADC	DIO02+2
	      STA	DIO02+2
	      JMP	?PROCCUR_02
?PROCCUR_022
	      LDA	#08H
	      CLC
	      ADC	DIO02+2
	      STA	DIO02+2
?PROCCUR_02
?PROCCUR_E
	      RTS
;-------------------------------------------------------------------------------
PROCH_H
	      LDA	CURON
	      CMP	#01H
	      BNE	?PROCH_H_E
	      LDA	CURPOSI
	      CMP	#00H
	      BNE	?PROCH_H_E
	      LDA	#KUP
	      BIT	KEY1_1
	      BEQ	?PROCH_H_S1
	      JMP	?PROCH_H_S11
?PROCH_H_S1
	      BIT	KEY2_1
	      BEQ	?PROCH_H_01
?PROCH_H_S11
	      LDA	H
	      SEC
	      SBC	#10H
	      STA	H
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	#6EH
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCH_H_E
?PROCH_H_01
	      LDA	#KDOWN
	      BIT	KEY1_1
	      BEQ	?PROCH_H_SE
	      JMP	?PROCH_H_SEE
?PROCH_H_SE
	      BIT	KEY2_1
	      BEQ	?PROCH_H_E
?PROCH_H_SEE
	      LDA	#10H
	      CLC
	      ADC	H
	      STA	H
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	#6EH
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCH_H_E

?PROCH_H_E
	      RTS
;-------------------------------------------------------------------------------
PROCH_L
	      LDA	CURON
	      CMP	#01H
	      BNE	?PROCH_L_E
	      LDA	CURPOSI
	      CMP	#01H
	      BNE	?PROCH_L_E
	      LDA	#KUP
	      BIT	KEY1_1
	      BEQ	?PROCH_L_S1
	      JMP	?PROCH_L_S11
?PROCH_L_S1
	      BIT	KEY2_1
	      BEQ	?PROCH_L_01
?PROCH_L_S11
	      LDA	H
	      SEC
	      SBC	#01H
	      AND	#0FH
	      TAX
	      LDA	H
	      AND	#F0H
	      STA	H
	      TXA
	      ORA	H
	      STA	H
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	#70H
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCH_L_E
?PROCH_L_01
	      LDA	#KDOWN
	      BIT	KEY1_1
	      BEQ	?PROCH_L_SE
	      JMP	?PROCH_L_SEE
?PROCH_L_SE
	      BIT	KEY2_1
	      BEQ	?PROCH_L_E
?PROCH_L_SEE
	      LDA	#01H
	      CLC
	      ADC	H
	      AND	#0FH
	      TAX
	      LDA	H
	      AND	#F0H
	      STA	H
	      TXA
	      ORA	H
	      STA	H
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	#70H
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCH_L_E

?PROCH_L_E
	      RTS
;-------------------------------------------------------------------------------
PROCC_H
	      LDA	CURON
	      CMP	#01H
	      BNE	?PROCC_H_E
	      LDA	CURPOSI
	      CMP	#02H
	      BNE	?PROCC_H_E
	      LDA	#KUP
	      BIT	KEY1_1
	      BEQ	?PROCC_H_S1
	      JMP	?PROCC_H_S11
?PROCC_H_S1
	      BIT	KEY2_1
	      BEQ	?PROCC_H_01
?PROCC_H_S11
	      LDA	C
	      SEC
	      SBC	#10H
	      STA	C
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	#74H
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCC_H_E
?PROCC_H_01
	      LDA	#KDOWN
	      BIT	KEY1_1
	      BEQ	?PROCC_H_SE
	      JMP	?PROCC_H_SEE
?PROCC_H_SE
	      BIT	KEY2_1
	      BEQ	?PROCC_H_E
?PROCC_H_SEE
	      LDA	#10H
	      CLC
	      ADC	C
	      STA	C
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	#74H
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCC_H_E

?PROCC_H_E
	      RTS
;-------------------------------------------------------------------------------
PROCC_L
	      LDA	CURON
	      CMP	#01H
	      BNE	?PROCC_L_E
	      LDA	CURPOSI
	      CMP	#03H
	      BNE	?PROCC_L_E
	      LDA	#KUP
	      BIT	KEY1_1
	      BEQ	?PROCC_L_S1
	      JMP	?PROCC_L_S11
?PROCC_L_S1
	      BIT	KEY2_1
	      BEQ	?PROCC_L_01
?PROCC_L_S11
	      LDA	C
	      SEC
	      SBC	#01H
	      AND	#0FH
	      TAX
	      LDA	C
	      AND	#F0H
	      STA	C
	      TXA
	      ORA	C
	      STA	C
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	#76H
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCC_L_E
?PROCC_L_01
	      LDA	#KDOWN
	      BIT	KEY1_1
	      BEQ	?PROCC_L_SE
	      JMP	?PROCC_L_SEE
?PROCC_L_SE
	      BIT	KEY2_1
	      BEQ	?PROCC_L_E
?PROCC_L_SEE
	      LDA	#01H
	      CLC
	      ADC	C
	      AND	#0FH
	      TAX
	      LDA	C
	      AND	#F0H
	      STA	C
	      TXA
	      ORA	C
	      STA	C
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	#76H
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCC_L_E

?PROCC_L_E
	      RTS
;-------------------------------------------------------------------------------
PROCR_H
	      LDA	CURON
	      CMP	#01H
	      BNE	?PROCR_H_E
	      LDA	CURPOSI
	      CMP	#04H
	      BNE	?PROCR_H_E
	      LDA	#KUP
	      BIT	KEY1_1
	      BEQ	?PROCR_H_S1
	      JMP	?PROCR_H_S11
?PROCR_H_S1
	      BIT	KEY2_1
	      BEQ	?PROCR_H_01
?PROCR_H_S11
	      LDA	R
	      SEC
	      SBC	#10H
	      STA	R
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	#7AH
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCR_H_E
?PROCR_H_01
	      LDA	#KDOWN
	      BIT	KEY1_1
	      BEQ	?PROCR_H_SE
	      JMP	?PROCR_H_SEE
?PROCR_H_SE
	      BIT	KEY2_1
	      BEQ	?PROCR_H_E
?PROCR_H_SEE
	      LDA	#10H
	      CLC
	      ADC	R
	      STA	R
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	#7AH
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCR_H_E

?PROCR_H_E
	      RTS
;-------------------------------------------------------------------------------
PROCR_L
	      LDA	CURON
	      CMP	#01H
	      BNE	?PROCR_L_E
	      LDA	CURPOSI
	      CMP	#05H
	      BNE	?PROCR_L_E
	      LDA	#KUP
	      BIT	KEY1_1
	      BEQ	?PROCR_L_S1
	      JMP	?PROCR_L_S11
?PROCR_L_S1
	      BIT	KEY2_1
	      BEQ	?PROCR_L_01
?PROCR_L_S11
	      LDA	R
	      SEC
	      SBC	#01H
	      AND	#0FH
	      TAX
	      LDA	R
	      AND	#F0H
	      STA	R
	      TXA
	      ORA	R
	      STA	R
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	#7CH
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCR_L_E
?PROCR_L_01
	      LDA	#KDOWN
	      BIT	KEY1_1
	      BEQ	?PROCR_L_SE
	      JMP	?PROCR_L_SEE
?PROCR_L_SE
	      BIT	KEY2_1
	      BEQ	?PROCR_L_E
?PROCR_L_SEE
	      LDA	#01H
	      CLC
	      ADC	R
	      AND	#0FH
	      TAX
	      LDA	R
	      AND	#F0H
	      STA	R
	      TXA
	      ORA	R
	      STA	R
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	#7CH
	      STA	NUMADD
	      LDA	#11H
	      STA	NUMADD+1
	      JSR	SHOWNUM
	      JMP	?PROCR_L_E

?PROCR_L_E
	      RTS
;-------------------------------------------------------------------------------
D_0
 DW $0800
D_1
 DW $0802
D_2
 DW $0804
D_3
 DW $0806
D_4
 DW $0808
D_5
 DW $080A
D_6
 DW $080C
D_7
 DW $080E
D_8
 DW $0810
D_9
 DW $0812
D_A
 DW $0814
D_B
 DW $0816
D_C
 DW $0818
D_D
 DW $081A
D_E
 DW $081C
D_F
 DW $081E
;-------------------------------------------------------------------------------
SHOWNUM
	      LDA	HILO
	      CMP	#00H
	      BNE	?SHOWNUM_01
	      LDA	#0FH
	      AND	NUM
	      STA	NUM
?SHOWNUM_01
	      LDA	HILO
	      CMP	#01H
	      BNE	?SHOWNUM_02
	      LSR	NUM
	      LSR	NUM
	      LSR	NUM
	      LSR	NUM
?SHOWNUM_02
	      LDA	NUM
	      CMP	#00H
	      BNE	?SHOWNUM_0
	      LDA	#<D_0
	      STA	SOUR_ADD
	      LDA	#>D_0
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_0
	      LDA	NUM
	      CMP	#01H
	      BNE	?SHOWNUM_1
	      LDA	#<D_1
	      STA	SOUR_ADD
	      LDA	#>D_1
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_1
	      LDA	NUM
	      CMP	#02H
	      BNE	?SHOWNUM_2
	      LDA	#<D_2
	      STA	SOUR_ADD
	      LDA	#>D_2
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_2
	      LDA	NUM
	      CMP	#03H
	      BNE	?SHOWNUM_3
	      LDA	#<D_3
	      STA	SOUR_ADD
	      LDA	#>D_3
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_3
	      LDA	NUM
	      CMP	#04H
	      BNE	?SHOWNUM_4
	      LDA	#<D_4
	      STA	SOUR_ADD
	      LDA	#>D_4
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_4
	      LDA	NUM
	      CMP	#05H
	      BNE	?SHOWNUM_5
	      LDA	#<D_5
	      STA	SOUR_ADD
	      LDA	#>D_5
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_5
	      LDA	NUM
	      CMP	#06H
	      BNE	?SHOWNUM_6
	      LDA	#<D_6
	      STA	SOUR_ADD
	      LDA	#>D_6
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_6
	      LDA	NUM
	      CMP	#07H
	      BNE	?SHOWNUM_7
	      LDA	#<D_7
	      STA	SOUR_ADD
	      LDA	#>D_7
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_7
	      LDA	NUM
	      CMP	#08H
	      BNE	?SHOWNUM_8
	      LDA	#<D_8
	      STA	SOUR_ADD
	      LDA	#>D_8
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_8
	      LDA	NUM
	      CMP	#09H
	      BNE	?SHOWNUM_9
	      LDA	#<D_9
	      STA	SOUR_ADD
	      LDA	#>D_9
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_9
	      LDA	NUM
	      CMP	#0AH
	      BNE	?SHOWNUM_A
	      LDA	#<D_A
	      STA	SOUR_ADD
	      LDA	#>D_A
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_A
	      LDA	NUM
	      CMP	#0BH
	      BNE	?SHOWNUM_B
	      LDA	#<D_B
	      STA	SOUR_ADD
	      LDA	#>D_B
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_B
	      LDA	NUM
	      CMP	#0CH
	      BNE	?SHOWNUM_C
	      LDA	#<D_C
	      STA	SOUR_ADD
	      LDA	#>D_C
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_C
	      LDA	NUM
	      CMP	#0DH
	      BNE	?SHOWNUM_D
	      LDA	#<D_D
	      STA	SOUR_ADD
	      LDA	#>D_D
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_D
	      LDA	NUM
	      CMP	#0EH
	      BNE	?SHOWNUM_E
	      LDA	#<D_E
	      STA	SOUR_ADD
	      LDA	#>D_E
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_E
	      LDA	NUM
	      CMP	#0FH
	      BNE	?SHOWNUM_F
	      LDA	#<D_F
	      STA	SOUR_ADD
	      LDA	#>D_F
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      JMP	?SHOWNUM_END
?SHOWNUM_F

?SHOWNUM_END

	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1

	      LDA	NUMADD
	      STA	DEST_ADD
	      LDA	NUMADD+1
	      STA	DEST_ADD+1

	      LDA	#1
	      STA	BGX
	      LDA	#1
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
	      RTS
;-------------------------------------------------------------------------------
PROCESSC
	      LDA	#KA
	      BIT	KEY1_1
	      BEQ	?PROCESSC_SE
	      JMP	?PROCESSC_SEE
?PROCESSC_SE
	      BIT	KEY2_1
	      BEQ	?PROCESSC_E
?PROCESSC_SEE
	      LDA	CURON
	      CMP	#00H
	      BNE	?PROCESSC_E
	      LDA	DIO01+02
	      CMP	#184
	      BMI	?PROCESSC_E
	      CMP	#248
	      BPL	?PROCESSC_E
	      LDA	DIO01+03
	      CMP	#32
	      BMI	?PROCESSC_E
	      CMP	#48
	      BPL	?PROCESSC_E
	      LDA	#01H
	      STA	CURON
	      STA	CURCON
	      LDA	#00H
	      STA	CURSW
	      STA	CURPOSI
	      LDA	#00H
	      STA	DIO01
	      LDA	#80H
	      STA	DIO01+2H
	      LDA	#28H
	      STA	DIO01+3H
	      LDA	#B8H
	      STA	DIO02+2H
	      LDA	#28H
	      STA	DIO02+3H
?PROCESSC_E
	      RTS
;-------------------------------------------------------------------------------
ENDC
	      LDA	#KA
	      BIT	KEY1_1
	      BEQ	?ENDC_SE
	      JMP	?ENDC_SEE
?ENDC_SE
	      BIT	KEY2_1
	      BEQ	?ENDC_E
?ENDC_SEE
	      LDA	CURON
	      CMP	#01H
	      BNE	?ENDC_E
	      LDA	#01H
	      STA	DIO01
	      LDA	#00H
	      STA	DIO02
	      LDA	#00H
	      STA	CURON
?ENDC_E
	      RTS
;-------------------------------------------------------------------------------
PROCESSF
	      LDA	#KA
	      BIT	KEY1_0
	      BEQ	?PROCESSF_SE
	      JMP	?PROCESSF_SEE
?PROCESSF_SE
	      BIT	KEY2_0
	      BEQ	?PROCESSF_E
?PROCESSF_SEE
	      LDA	DIO01+02
	      CMP	#24
	      BMI	?PROCESSF_E
	      CMP	#68
	      BPL	?PROCESSF_E
	      LDA	DIO01+03
	      CMP	#16
	      BMI	?PROCESSF_E
	      CMP	#28
	      BPL	?PROCESSF_E
	      LDA	FORMAT_SW
	      CMP	#01H
	      BEQ	?PROCESSF_END
	      LDA	#01H
	      STA	FORMAT_SW
	      JSR	PRESS_F
	      JMP	?PROCESSF_END
?PROCESSF_E

	      LDA	FORMAT_SW
	      CMP	#01H
	      BNE	?PROCESSF_END
	      LDA	#00H
	      STA	FORMAT_SW
	      JSR	UPRESS_F
	      JSR	FORMAT
?PROCESSF_END
	      RTS
;-------------------------------------------------------------------------------
PROCESSR
	      LDA	#KA
	      BIT	KEY1_0
	      BEQ	?PROCESSR_SE
	      JMP	?PROCESSR_SEE
?PROCESSR_SE
	      BIT	KEY2_0
	      BEQ	?PROCESSR_E
?PROCESSR_SEE
	      LDA	DIO01+02
	      CMP	#80
	      BMI	?PROCESSR_E
	      CMP	#124
	      BPL	?PROCESSR_E
	      LDA	DIO01+03
	      CMP	#16
	      BMI	?PROCESSR_E
	      CMP	#28
	      BPL	?PROCESSR_E
	      LDA	READ_SW
	      CMP	#01H
	      BEQ	?PROCESSR_END
	      LDA	#01H
	      STA	READ_SW
	      JSR	PRESS_R
	      JMP	?PROCESSR_END
?PROCESSR_E

	      LDA	READ_SW
	      CMP	#01H
	      BNE	?PROCESSR_END
	      LDA	#00H
	      STA	READ_SW
	      JSR	UPRESS_R
	      JSR	READ
?PROCESSR_END
	      RTS
;-------------------------------------------------------------------------------
PROCESSW
	      LDA	#KA
	      BIT	KEY1_0
	      BEQ	?PROCESSW_SE
	      JMP	?PROCESSW_SEE
?PROCESSW_SE
	      BIT	KEY2_0
	      BEQ	?PROCESSW_E
?PROCESSW_SEE
	      LDA	DIO01+02
	      CMP	#136
	      BMI	?PROCESSW_E
	      CMP	#180
	      BPL	?PROCESSW_E
	      LDA	DIO01+03
	      CMP	#16
	      BMI	?PROCESSW_E
	      CMP	#28
	      BPL	?PROCESSW_E
	      LDA	WRITE_SW
	      CMP	#01H
	      BEQ	?PROCESSW_END
	      LDA	#01H
	      STA	WRITE_SW
	      JSR	PRESS_W
	      JMP	?PROCESSW_END
?PROCESSW_E

	      LDA	WRITE_SW
	      CMP	#01H
	      BNE	?PROCESSW_END
	      LDA	#00H
	      STA	WRITE_SW
	      JSR	UPRESS_W
	      JSR	WRITE
?PROCESSW_END
	      RTS
;-------------------------------------------------------------------------------
FORMAT
	      JSR	WAITBLANKING
	      LDA	#00H
	      STA	$2000H
	      LDA	C
	      STA	RC
	      LDA	H
	      STA	RH
	      LDA	R
	      STA	RR

	      LDA	#00H
	      STA	C
	      LDA	#00H
	      STA	FormatC
	      JSR	Motor_On
	      JSR	Recalibrate
	      JSR	Motor_Off


?FORMAT_01
	      JSR	Motor_On
	      LDA	#00H
	      STA	H
	      LDA	#00H
	      STA	FormatH
	      JSR	Seek
	      JSR	Format_Track
	      JSR	Motor_Off
	      LDA	ERROR_SW
	      CMP	#01H
	      BEQ	?FORMAT_E

	      JSR	Motor_On
	      LDA	#01H
	      STA	FormatH
	      JSR	Format_Track
	      JSR	Motor_Off
	      LDA	ERROR_SW
	      CMP	#01H
	      BEQ	?FORMAT_E

	      LDA	#01H
	      STA	C

	      INC	FormatC
	      LDA	FormatC
	      CMP	#50H
	      BNE	?FORMAT_01


	      JSR	WRITE0
	      JSR	WRITEBOOT
	      JSR	WRITEFAT
?FORMAT_E

	      LDA	RC
	      STA	C
	      LDA	RH
	      STA	H
	      LDA	RR
	      STA	R
	      LDA	#80H
	      STA	$2000H

	      RTS
;-------------------------------------------------------------------------------
READ
	      JSR	WAITBLANKING
	      LDA	#00H
	      STA	$2000H
	      JSR	Motor_On
	      JSR	Recalibrate
	      JSR	Seek
	      JSR	Read
	      JSR	Motor_Off
	      LDA	#80H
	      STA	$2000H
	      JSR	DISPLAY0
	      RTS
;-------------------------------------------------------------------------------
WRITE
	      JSR	WAITBLANKING
	      LDA	#00H
	      STA	$2000H
	      JSR	Motor_On
	      JSR	Recalibrate
	      JSR	Seek
	      JSR	Write
	      JSR	Motor_Off
	      LDA	#80H
	      STA	$2000H
	      RTS
;-------------------------------------------------------------------------------
WRITE0
	      LDA	#<600H
	      STA	DEST_ADD
	      LDA	#>600H
	      STA	DEST_ADD+1
	      LDY	#00H
	      LDA	#00H
WRITE0_01
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#00H
	      BNE	WRITE0_01
	      INC	DEST_ADD+1
WRITE0_02
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#00H
	      BNE	WRITE0_02


	      JSR	Motor_On
	      JSR	Recalibrate
	      LDA	#00H
	      STA	H
	      LDA	#00H
	      STA	C
	      JSR	Seek
	      JSR	Motor_Off

	      JSR	Motor_On
	      LDA	#03H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#04H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#05H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#06H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#07H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#08H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#09H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0AH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0CH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0DH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0EH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0FH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#10H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#11H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#12H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off


	      JSR	Motor_On
	      LDA	#01H
	      STA	H
	      JSR	Seek
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#01H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#02H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#03H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#04H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#05H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#06H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#07H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#08H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#09H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0AH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0BH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0CH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0DH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0EH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0FH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      RTS
;-------------------------------------------------------------------------------
WRITEBOOT
	      LDA	#<600H
	      STA	DEST_ADD
	      LDA	#>600H
	      STA	DEST_ADD+1
	      LDA	#<BOOT_D
	      STA	SOUR_ADD
	      LDA	#>BOOT_D
	      STA	SOUR_ADD+1
	      LDY	#00H
WRITEBOOT_01
	      LDA	(SOUR_ADD),Y
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#00H
	      BNE	WRITEBOOT_01
	      INC	DEST_ADD+1
	      INC	SOUR_ADD+1
WRITEBOOT_02
	      LDA	(SOUR_ADD),Y
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#00H
	      BNE	WRITEBOOT_02

	      JSR	Motor_On
	      JSR	Recalibrate
	      LDA	#00H
	      STA	H
	      LDA	#00H
	      STA	C
	      JSR	Seek
	      JSR	Motor_Off

	      JSR	Motor_On
	      LDA	#01H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      RTS
;-------------------------------------------------------------------------------
WRITEFAT
	      LDA	#<600H
	      STA	DEST_ADD
	      LDA	#>600H
	      STA	DEST_ADD+1
	      LDA	#<FAT_D
	      STA	SOUR_ADD
	      LDA	#>FAT_D
	      STA	SOUR_ADD+1
	      LDY	#00H
WRITEFAT_01
	      LDA	(SOUR_ADD),Y
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#00H
	      BNE	WRITEFAT_01
	      INC	DEST_ADD+1
	      INC	SOUR_ADD+1
WRITEFAT_02
	      LDA	(SOUR_ADD),Y
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#00H
	      BNE	WRITEFAT_02

	      JSR	Motor_On
	      JSR	Recalibrate
	      LDA	#00H
	      STA	H
	      LDA	#00H
	      STA	C
	      JSR	Seek
	      JSR	Motor_Off

	      JSR	Motor_On
	      LDA	#02H
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      JSR	Motor_On
	      LDA	#0BH
	      STA	R
	      JSR	Write
	      JSR	Motor_Off
	      RTS
;-------------------------------------------------------------------------------
BOOT_D
  DB EBH,3CH,90H,4DH,53H,44H,4FH,53H,35H,2EH,30H,00H,02H,01H,01H,00H
  DB 02H,E0H,00H,40H,0BH,F0H,09H,00H,12H,00H,02H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,29H,ECH,17H,10H,2EH,4EH,4FH,20H,4EH,41H
  DB 4DH,45H,20H,20H,20H,20H,46H,41H,54H,31H,32H,20H,20H,20H,FAH,33H
  DB C0H,8EH,D0H,BCH,00H,7CH,16H,07H,BBH,78H,00H,36H,C5H,37H,1EH,56H
  DB 16H,53H,BFH,3EH,7CH,B9H,0BH,00H,FCH,F3H,A4H,06H,1FH,C6H,45H,FEH
  DB 0FH,8BH,0EH,18H,7CH,88H,4DH,F9H,89H,47H,02H,C7H,07H,3EH,7CH,FBH
  DB CDH,13H,72H,79H,33H,C0H,39H,06H,13H,7CH,74H,08H,8BH,0EH,13H,7CH
  DB 89H,0EH,20H,7CH,A0H,10H,7CH,F7H,26H,16H,7CH,03H,06H,1CH,7CH,13H
  DB 16H,1EH,7CH,03H,06H,0EH,7CH,83H,D2H,00H,A3H,50H,7CH,89H,16H,52H
  DB 7CH,A3H,49H,7CH,89H,16H,4BH,7CH,B8H,20H,00H,F7H,26H,11H,7CH,8BH
  DB 1EH,0BH,7CH,03H,C3H,48H,F7H,F3H,01H,06H,49H,7CH,83H,16H,4BH,7CH
  DB 00H,BBH,00H,05H,8BH,16H,52H,7CH,A1H,50H,7CH,E8H,92H,00H,72H,1DH
  DB B0H,01H,E8H,ACH,00H,72H,16H,8BH,FBH,B9H,0BH,00H,BEH,E6H,7DH,F3H
  DB A6H,75H,0AH,8DH,7FH,20H,B9H,0BH,00H,F3H,A6H,74H,18H,BEH,9EH,7DH
  DB E8H,5FH,00H,33H,C0H,CDH,16H,5EH,1FH,8FH,04H,8FH,44H,02H,CDH,19H

  DB 58H,58H,58H,EBH,E8H,8BH,47H,1AH,48H,48H,8AH,1EH,0DH,7CH,32H,FFH
  DB F7H,E3H,03H,06H,49H,7CH,13H,16H,4BH,7CH,BBH,00H,07H,B9H,03H,00H
  DB 50H,52H,51H,E8H,3AH,00H,72H,D8H,B0H,01H,E8H,54H,00H,59H,5AH,58H
  DB 72H,BBH,05H,01H,00H,83H,D2H,00H,03H,1EH,0BH,7CH,E2H,E2H,8AH,2EH
  DB 15H,7CH,8AH,16H,24H,7CH,8BH,1EH,49H,7CH,A1H,4BH,7CH,EAH,00H,00H
  DB 70H,00H,ACH,0AH,C0H,74H,29H,B4H,0EH,BBH,07H,00H,CDH,10H,EBH,F2H
  DB 3BH,16H,18H,7CH,73H,19H,F7H,36H,18H,7CH,FEH,C2H,88H,16H,4FH,7CH
  DB 33H,D2H,F7H,36H,1AH,7CH,88H,16H,25H,7CH,A3H,4DH,7CH,F8H,C3H,F9H
  DB C3H,B4H,02H,8BH,16H,4DH,7CH,B1H,06H,D2H,E6H,0AH,36H,4FH,7CH,8BH
  DB CAH,86H,E9H,8AH,16H,24H,7CH,8AH,36H,25H,7CH,CDH,13H,C3H,0DH,0AH
  DB 4EH,6FH,6EH,2DH,53H,79H,73H,74H,65H,6DH,20H,64H,69H,73H,6BH,20H
  DB 6FH,72H,20H,64H,69H,73H,6BH,20H,65H,72H,72H,6FH,72H,0DH,0AH,52H
  DB 65H,70H,6CH,61H,63H,65H,20H,61H,6EH,64H,20H,70H,72H,65H,73H,73H
  DB 20H,61H,6EH,79H,20H,6BH,65H,79H,20H,77H,68H,65H,6EH,20H,72H,65H
  DB 61H,64H,79H,0DH,0AH,00H,49H,4FH,20H,20H,20H,20H,20H,20H,53H,59H
  DB 53H,4DH,53H,44H,4FH,53H,20H,20H,20H,53H,59H,53H,00H,00H,55H,AAH
;-------------------------------------------------------------------------------
FAT_D
  DB F0H,FFH,FFH,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
  DB 00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
;-------------------------------------------------------------------------------
D_FORMAT
  DW	$0B80,$0B82,$0B84,$0B86,$0B88,$0B8A
  DW	$0BA0,$0BA2,$0BA4,$0BA6,$0BA8,$0BAA
D_UFORMAT
  DW	$0846,$0848,$084A,$084C,$084E,$0850
  DW	$0866,$0868,$086A,$086C,$086E,$0870
;-------------------------------------------------------------------------------
PRESS_F
	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_FORMAT
	      STA	SOUR_ADD
	      LDA	#>D_FORMAT
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#86H
	      STA	DEST_ADD
	      LDA	#10H
	      STA	DEST_ADD+1

	      LDA	#6
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
	      RTS
;-------------------------------------------------------------------------------
UPRESS_F
	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_UFORMAT
	      STA	SOUR_ADD
	      LDA	#>D_UFORMAT
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#86H
	      STA	DEST_ADD
	      LDA	#10H
	      STA	DEST_ADD+1

	      LDA	#6
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
	      RTS
;-------------------------------------------------------------------------------
D_READ
  DW	$0B8C,$0B8E,$0B90,$0B92,$0B94,$0B96
  DW	$0BAC,$0BAE,$0BB0,$0BB2,$0BB4,$0BB6
D_UREAD
  DW	$0854,$0856,$0858,$085A,$085C,$085E
  DW	$0874,$0876,$0878,$087A,$087C,$087E
;-------------------------------------------------------------------------------
PRESS_R
	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_READ
	      STA	SOUR_ADD
	      LDA	#>D_READ
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#94H
	      STA	DEST_ADD
	      LDA	#10H
	      STA	DEST_ADD+1

	      LDA	#6
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
	      RTS
;-------------------------------------------------------------------------------
UPRESS_R
	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_UREAD
	      STA	SOUR_ADD
	      LDA	#>D_UREAD
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#94H
	      STA	DEST_ADD
	      LDA	#10H
	      STA	DEST_ADD+1

	      LDA	#6
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
	      RTS
;-------------------------------------------------------------------------------
D_WRITE
  DW	$0B98,$0B9A,$0B9C,$0B9E,$0F40,$0F42
  DW	$0BB8,$0BBA,$0BBC,$0BBE,$0F60,$0F62
D_UWRITE
  DW	$0C02,$0C04,$0C06,$0C08,$0C0A,$0C0C
  DW	$0C22,$0C24,$0C26,$0C28,$0C2A,$0C2C
;-------------------------------------------------------------------------------
PRESS_W
	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_WRITE
	      STA	SOUR_ADD
	      LDA	#>D_WRITE
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#A2H
	      STA	DEST_ADD
	      LDA	#10H
	      STA	DEST_ADD+1

	      LDA	#6
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
	      RTS
;-------------------------------------------------------------------------------
UPRESS_W
	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_UWRITE
	      STA	SOUR_ADD
	      LDA	#>D_UWRITE
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#A2H
	      STA	DEST_ADD
	      LDA	#10H
	      STA	DEST_ADD+1

	      LDA	#6
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
	      RTS
;-------------------------------------------------------------------------------
DISPLAY0
	      LDA	#00H
	      STA	DISP_ADD
	      LDA	#06H
	      STA	DISP_ADD+1
	      LDA	#00H
	      STA	SCR_ADD
	      LDA	#12H
	      STA	SCR_ADD+1


?DISPLAY0_00
	      LDY	#00H
	      LDA	(DISP_ADD),Y
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	SCR_ADD
	      STA	NUMADD
	      LDA	SCR_ADD+1
	      STA	NUMADD+1
	      JSR	SHOWNUM

	      LDA	#02H
	      CLC
	      ADC	SCR_ADD
	      BCC	?DISPLAY0_01
	      INC	SCR_ADD+1
?DISPLAY0_01
	      STA	SCR_ADD

	      LDY	#00H
	      LDA	(DISP_ADD),Y
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	SCR_ADD
	      STA	NUMADD
	      LDA	SCR_ADD+1
	      STA	NUMADD+1
	      JSR	SHOWNUM

	      LDA	#02H
	      CLC
	      ADC	SCR_ADD
	      BCC	?DISPLAY0_02
	      INC	SCR_ADD+1
?DISPLAY0_02
	      STA	SCR_ADD

	      INC	DISP_ADD
	      BNE	?DISPLAY0_00

	      LDA	#01H
	      STA	DISP_SW
	      RTS
;-------------------------------------------------------------------------------
DISPLAY1
	      LDA	#00H
	      STA	DISP_ADD
	      LDA	#07H
	      STA	DISP_ADD+1
	      LDA	#00H
	      STA	SCR_ADD
	      LDA	#12H
	      STA	SCR_ADD+1


?DISPLAY1_00
	      LDY	#00H
	      LDA	(DISP_ADD),Y
	      STA	NUM
	      LDA	#01H
	      STA	HILO
	      LDA	SCR_ADD
	      STA	NUMADD
	      LDA	SCR_ADD+1
	      STA	NUMADD+1
	      JSR	SHOWNUM

	      LDA	#02H
	      CLC
	      ADC	SCR_ADD
	      BCC	?DISPLAY1_01
	      INC	SCR_ADD+1
?DISPLAY1_01
	      STA	SCR_ADD

	      LDY	#00H
	      LDA	(DISP_ADD),Y
	      STA	NUM
	      LDA	#00H
	      STA	HILO
	      LDA	SCR_ADD
	      STA	NUMADD
	      LDA	SCR_ADD+1
	      STA	NUMADD+1
	      JSR	SHOWNUM

	      LDA	#02H
	      CLC
	      ADC	SCR_ADD
	      BCC	?DISPLAY1_02
	      INC	SCR_ADD+1
?DISPLAY1_02
	      STA	SCR_ADD

	      INC	DISP_ADD
	      BNE	?DISPLAY1_00

	      LDA	#00H
	      STA	DISP_SW
	      RTS
;-------------------------------------------------------------------------------
READKEY
	      LDA	#00H
	      STA	KEY1_0
	      STA	KEY2_0
	      LDA	#01H
	      STA	$4016
	      LDA	#00H
	      STA	$4016

	      LDA	#00H
	      STA	ROLTIME
	      JSR	READKEY1
	      LDA	#00H
	      STA	ROLTIME
	      JSR	READKEY2
	      RTS
;-------------------------------------------------------------------------------
READKEY1
	      LDX	#08H
READKEY1_02
	      LDA	$4017
	      AND	#01H
	      LDY	ROLTIME
READKEY1_00
	      CPY	#00H
	      BEQ	READKEY1_01
	      CLC
	      ROL	A
	      DEY
	      JMP	READKEY1_00
READKEY1_01
	      ORA	KEY1_0
	      STA	KEY1_0
	      INC	ROLTIME
	      DEX
	      BNE	READKEY1_02
	      LDA	KEY1_2
	      EOR	KEY1_0
	      STA	KEY1_1
	      CLC
	      LDA	#00H
	      SBC	KEY1_2
	      AND	KEY1_1
	      STA	KEY1_1
	      LDA	KEY1_0
	      STA	KEY1_2
	      RTS
;-------------------------------------------------------------------------------
READKEY2
	      LDX	#08H
READKEY2_02
	      LDA	$4016
	      AND	#01H
	      LDY	ROLTIME
READKEY2_00
	      CPY	#00H
	      BEQ	READKEY2_01
	      CLC
	      ROL	A
	      DEY
	      JMP	READKEY2_00
READKEY2_01
	      ORA	KEY2_0
	      STA	KEY2_0
	      INC	ROLTIME
	      DEX
	      BNE	READKEY2_02
	      LDA	KEY2_2
	      EOR	KEY2_0
	      STA	KEY2_1
	      CLC
	      LDA	#00H
	      SBC	KEY2_2
	      AND	KEY2_1
	      STA	KEY2_1
	      LDA	KEY2_0
	      STA	KEY2_2
	      RTS
;-------------------------------------------------------------------------------
CLS_R
	      LDA	#FFH
	      STA	CON
	      LDA	#07H
	      STA	CON+1
	      LDA	#00H
	      STA	DEST_ADD
	      LDA	#50H
	      STA	DEST_ADD+1


	      LDY	#00H
CLS_R_0
	      DEC	CON
	      BNE	CLS_R_1
	      DEC	CON+1
	      BNE	CLS_R_1
	      JMP	CLS_R_E
CLS_R_1
	      LDA	#00H
	      STA	(DEST_ADD),Y
	      INC	DEST_ADD
	      BNE	CLS_R_0
	      INC	DEST_ADD+1
	      JMP	CLS_R_0
CLS_R_E
	      LDA	#E8H
	      STA	CON
	      LDA	#02H
	      STA	CON+1
	      LDA	#12H
	      STA	DEST_ADD
	      LDA	#00H
	      STA	DEST_ADD+1


	      LDY	#00H
CLS_R1_0
	      DEC	CON
	      BNE	CLS_R1_1
	      DEC	CON+1
	      BNE	CLS_R1_1
	      JMP	CLS_R1_E
CLS_R1_1
	      LDA	#00H
	      STA	(DEST_ADD),Y
	      INC	DEST_ADD
	      BNE	CLS_R1_0
	      INC	DEST_ADD+1
	      JMP	CLS_R1_0
CLS_R1_E
	      RTS
;-------------------------------------------------------------------------------
CLS_DIO
	      LDA	#00H
	      STA	CON
	      LDA	#02H
	      STA	CON+1
	      LDA	#00H
	      STA	DEST_ADD
	      LDA	#03H
	      STA	DEST_ADD+1


	      LDY	#00H
CLS_DIO_0
	      DEC	CON
	      BNE	CLS_DIO_1
	      DEC	CON+1
	      BNE	CLS_DIO_1
	      JMP	CLS_DIO_E
CLS_DIO_1
	      LDA	#00H
	      STA	(DEST_ADD),Y
	      INC	DEST_ADD
	      BNE	CLS_DIO_0
	      INC	DEST_ADD+1
	      JMP	CLS_DIO_0
CLS_DIO_E
	      LDA	#00H
	      STA	CON
	      LDA	#01H
	      STA	CON+1
	      LDA	#00H
	      STA	DEST_ADD
	      LDA	#05H
	      STA	DEST_ADD+1


	      LDY	#00H
CLS_DIO_2
	      DEC	CON
	      BNE	CLS_DIO_3
	      DEC	CON+1
	      BNE	CLS_DIO_3
	      JMP	CLS_DIO_E1
CLS_DIO_3
	      LDA	#00H
	      STA	(DEST_ADD),Y
	      INC	DEST_ADD
	      BNE	CLS_DIO_2
	      INC	DEST_ADD+1
	      JMP	CLS_DIO_2
CLS_DIO_E1
	      RTS
;-------------------------------------------------------------------------------
CLS_VR
	      LDA	#FFH
	      STA	CON
	      LDA	#27H
	      STA	CON+1

	      LDA	#00H
	      STA	$2006
	      STA	$2006

	      LDY	#00H
CLS_VR_0
	      DEC	CON
	      BNE	CLS_VR_1
	      DEC	CON+1
	      BNE	CLS_VR_1
	      JMP	CLS_VR_E
CLS_VR_1
	      LDA	#00H
	      STA	$2007
	      JMP	CLS_VR_0
CLS_VR_E
	      LDA	#FFH
	      STA	CON
	      LDA	#7FH
	      STA	CON+1

	      LDA	#80H
	      STA	$2006
	      LDA	#00H
	      STA	$2006

	      LDY	#00H
CLS_VR1_0
	      DEC	CON
	      BNE	CLS_VR1_1
	      DEC	CON+1
	      BNE	CLS_VR1_1
	      JMP	CLS_VR1_E
CLS_VR1_1
	      LDA	#00H
	      STA	$2007
	      JMP	CLS_VR1_0
CLS_VR1_E
	      RTS
;-------------------------------------------------------------------------------
CLS_COL
	      LDA	#40H
	      STA	DEST_ADD
	      LDA	#20H
	      STA	DEST_ADD+1
	      LDY	#00H
CLS_COL_1
	      LDA	#0EH
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#64
	      BNE	CLS_COL_1
	      RTS
;-------------------------------------------------------------------------------
SETCOLORTAB
	      LDA	#40H
	      STA	DEST_ADD
	      LDA	#20H
	      STA	DEST_ADD+1
	      LDY	#00H
SETCOLORTAB_1
	      LDA	(SOUR_ADD),Y
	      STA	(DEST_ADD),Y
	      INY
	      CPY	#64
	      BNE	SETCOLORTAB_1
	      RTS
;-------------------------------------------------------------------------------
WRBG

	      LDA	BANK_ADD
	      AND	#7FH
	      LSR	A
	      LSR	A
	      LSR	A
	      LSR	A
	      ORA	BANK_SW
	      STA	BANK_SW
	      STA	$4046



	      LDY	#00H
WRBG_0

	      LDA	DEST_ADD
	      STA	RDEST_ADD
	      LDA	DEST_ADD+1
	      STA	RDEST_ADD+1

	      LDA	BGX
	      STA	RBGX
WRBG_1
	      LDA	(SOUR_ADD),Y
	      STA	(RDEST_ADD),Y
	      INC	SOUR_ADD
	      BNE	WRBG_2_1
	      INC	SOUR_ADD+1
WRBG_2_1
	      INC	RDEST_ADD
	      BNE	WRBG_2_2
	      INC	RDEST_ADD+1
WRBG_2_2
	      LDA	(SOUR_ADD),Y
	      STA	(RDEST_ADD),Y
	      INC	SOUR_ADD
	      BNE	WRBG_2_3
	      INC	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      CMP	#F0H
	      BNE	WRBG_2_3
	      LDA	#00H
	      STA	SOUR_ADD
	      LDA	#E0H
	      STA	SOUR_ADD+1
	      INC	BANK_SW
	      LDA	BANK_SW
	      STA	$4046
WRBG_2_3
	      INC	RDEST_ADD
	      BNE	WRBG_2_4
	      INC	RDEST_ADD+1
WRBG_2_4
	      DEC	RBGX
	      BNE	WRBG_1

	      LDA	#40H
	      CLC
	      ADC	DEST_ADD
	      BCC	WRBG_3
	      INC	DEST_ADD+1
WRBG_3
	      STA	DEST_ADD

	      DEC	BGY
	      BNE	WRBG_0
	      LDA	#06H
	      STA	$4046
	      LDA	#01H
	      STA	WRBGSW
	      RTS
;-------------------------------------------------------------------------------
WRPATTERN
	      LDA	DEST_ADD+1
	      STA	$2006
	      LDA	DEST_ADD
	      STA	$2006
	      LDA	BANK_ADD
	      AND	#7FH
	      LSR	A
	      LSR	A
	      LSR	A
	      LSR	A
	      ORA	BANK_SW
	      STA	BANK_SW
	      STA	$4046

	      LDY	#00H


WRPATTERN_0
	      LDA	(SOUR_ADD),Y
	      STA	$2007
	      INC	SOUR_ADD
	      BNE	WRPATTERN_1
	      INC	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      CMP	#F0H
	      BNE	WRPATTERN_1
	      LDA	#00H
	      STA	SOUR_ADD
	      LDA	#E0H
	      STA	SOUR_ADD+1
	      INC	BANK_SW
	      LDA	BANK_SW
	      STA	$4046
WRPATTERN_1
	      DEC	CON
	      BNE	WRPATTERN_0
	      DEC	CON+1
	      BNE	WRPATTERN_0
	      LDA	#06H
	      STA	$4046

	      RTS
;-------------------------------------------------------------------------------
VWRPATTERN
	      LDA	VBANK_ADD
	      AND	#7FH
	      LSR	A
	      LSR	A
	      LSR	A
	      LSR	A
	      ORA	VBANK_SW
	      STA	VBANK_SW
	      STA	$4046

	      LDY	#00H


VWRPATTERN_0
	      LDA	(VSOUR_ADD),Y
	      STA	(VDEST_ADD),Y
	      INC	VDEST_ADD
	      BNE	VWRPATTERN_2
	      INC	VDEST_ADD+1
VWRPATTERN_2
	      INC	VSOUR_ADD
	      BNE	VWRPATTERN_1
	      INC	VSOUR_ADD+1
	      LDA	VSOUR_ADD+1
	      CMP	#F0H
	      BNE	VWRPATTERN_1
	      LDA	#00H
	      STA	VSOUR_ADD
	      LDA	#E0H
	      STA	VSOUR_ADD+1
	      INC	VBANK_SW
	      LDA	VBANK_SW
	      STA	$4046
VWRPATTERN_1
	      DEC	VCON
	      BNE	VWRPATTERN_0
	      DEC	VCON+1
	      BNE	VWRPATTERN_0
	      LDA	#06H
	      STA	$4046

	      RTS
;-------------------------------------------------------------------------------
WRPATTERN1
	      LDA	DEST_ADD+1
	      STA	$2006
	      LDA	DEST_ADD
	      STA	$2006

	      LDY	#00H


WRPATTERN1_0
	      LDA	(SOUR_ADD),Y
	      STA	$2007
	      INC	SOUR_ADD
	      BNE	WRPATTERN1_1
	      INC	SOUR_ADD+1
WRPATTERN1_1
	      DEC	CON
	      BNE	WRPATTERN1_0
	      DEC	CON+1
	      BNE	WRPATTERN1_0

	      RTS
;-------------------------------------------------------------------------------
WAITBLANKING
	      PHA
?WAITBLANKING_1
	      LDA	INT_SW
	      CMP	#01H
	      BEQ	?WAITBLANKING_2
	      LDA	BLANK_SW
	      CMP	#01H
	      BNE	?WAITBLANKING_1
?WAITBLANKING_2
	      LDA	#00H
	      STA	BLANK_SW
	      PLA
	      RTS
;-------------------------------------------------------------------------------
WAIT
	      NOP
	      DEC	WAIT_0
	      BNE	WAIT
	      DEC	WAIT_1
	      BNE	WAIT
	      RTS
;-------------------------------------------------------------------------------
;BYTE 0: SW
;BYTE 1: SNP
;BYTE 2: X
;BYTE 3: Y
;WORD 4: SNP_ADDRESS
;BYTE 6: DIO_BK
;-------------------------------------------------------------------------------
SETDIO
	      LDA	#<DIOBUFFER
	      STA	DEST_ADD
	      LDA	#>DIOBUFFER
	      STA	DEST_ADD+1


	      LDA	#<SPRITE
	      STA	SOUR_ADD
	      LDA	#>SPRITE
	      STA	SOUR_ADD+1
	      LDA	#<DIOBUFFER
	      STA	DEST_ADD
	      LDA	#>DIOBUFFER
	      STA	DEST_ADD+1

	      LDA	#10H
	      STA	DIONUM
	      LDA	#00H
	      STA	DIOTOTO


SETDIO_00
	      LDY	#00H
	      LDA	(SOUR_ADD),Y
	      CMP	#01H
	      BNE	SETDIO_J3
	      INY
	      LDA	(SOUR_ADD),Y
	      STA	SNP
	      INY
	      LDA	(SOUR_ADD),Y
	      STA	DIO_X
	      INY
	      LDA	(SOUR_ADD),Y
	      STA	DIO_Y
	      INY
	      LDA	(SOUR_ADD),Y
	      STA	SNP_ADD
	      INY
	      LDA	(SOUR_ADD),Y
	      STA	SNP_ADD+1
	      INY
	      LDA	(SOUR_ADD),Y
	      STA	DIOBANK_SW

	      LDX	SNP
SETDIO_04
	      CPX	#00H
	      BEQ	SETDIO_02
	      LDA	#03H
	      CLC
	      ADC	SNP_ADD
	      BCC	SETDIO_03
	      INC	SNP_ADD+1
SETDIO_03
	      STA	SNP_ADD
	      DEX
	      JMP	SETDIO_04
SETDIO_02
	      LDA	DIOBANK_SW
	      STA	BANK_SW
	      LDA	SNP_ADD+1
	      JSR	CH_BANK_ADD
	      STA	SNP_ADD+1
	      JSR	CH_BANK_SW
	      LDY	#00H
	      LDA	SNP_ADD
	      STA	REG_ADD
	      LDA	SNP_ADD+1
	      STA	REG_ADD+1

	      LDA	(REG_ADD),Y
	      STA	DIOLOOP

	      INC	REG_ADD
	      LDA	REG_ADD
	      JSR	CMPF0
	      LDA	(REG_ADD),Y
	      STA	DIO_ADD

	      INC	REG_ADD
	      LDA	REG_ADD
	      JSR	CMPF0
	      LDA	(REG_ADD),Y
	      STA	DIO_ADD+1

	      JMP	SETDIO_J2
SETDIO_J3
	      JMP	SETDIO_01
SETDIO_J2

	      LDX	#00H
	      LDY	#00H

	      LDA	DIOBANK_SW
	      STA	BANK_SW
	      LDA	DIO_ADD+1
	      JSR	CH_BANK_ADD
	      STA	DIO_ADD+1
	      JSR	CH_BANK_SW
	      LDA	DIO_ADD
	      STA	REG_ADD
	      LDA	DIO_ADD+1
	      STA	REG_ADD+1
SETDIO_07
	      JMP	SETDIO_J1
SETDIO_J0
	      JMP	SETDIO_00
SETDIO_J1
	      LDA	DIOLOOP
	      CMP	#00H
	      BEQ	SETDIO_05
	      INC	DIOTOTO
	      LDA	(REG_ADD),Y
	      CLC
	      ADC	DIO_Y
	      STA	(DEST_ADD,X)
	      INC	DEST_ADD
	      INC	REG_ADD
	      LDA	REG_ADD
	      JSR	CMPF0
	      LDA	(REG_ADD),Y
	      AND	#3FH
	      STA	(DEST_ADD,X)
	      INC	DEST_ADD
	      INC	REG_ADD
	      LDA	REG_ADD
	      JSR	CMPF0
	      LDA	(REG_ADD),Y
	      STA	(DEST_ADD,X)
	      INC	DEST_ADD
	      INC	REG_ADD
	      LDA	REG_ADD
	      JSR	CMPF0
	      LDA	(REG_ADD),Y
	      CLC
	      ADC	DIO_X
	      STA	(DEST_ADD,X)
	      INC	DEST_ADD
	      INC	REG_ADD
	      LDA	REG_ADD
	      JSR	CMPF0

	      DEC	DIOLOOP
	      JMP	SETDIO_07
SETDIO_05


SETDIO_01
	      LDA	#08H
	      CLC
	      ADC	SOUR_ADD
	      BCC	SETDIO_08
	      INC	SOUR_ADD+1
SETDIO_08
	      STA	SOUR_ADD
	      DEC	DIONUM
	      BNE	SETDIO_J0

	      LDA	#40H
	      CLC
	      SBC	DIOTOTO
	      STA	DIOTOTO
	      INC	DIOTOTO
	      CLC
	      ROL	DIOTOTO
	      ROL	DIOTOTO

SETDIO_0A
	      LDA	#00H
	      STA	(DEST_ADD,X)
	      INC	DEST_ADD
	      DEC	DIOTOTO
	      BNE	SETDIO_0A


	      LDA	#1
	      STA	WRSPSW

	      RTS
;-------------------------------------------------------------------------------
CH_BANK_ADD
	      STA	BANK_ADD
	      AND	#0FH
	      ORA	#E0H
	      RTS
;-------------------------------------------------------------------------------
CH_BANK_SW
	      LDA	BANK_ADD
	      AND	#7FH
	      LSR	A
	      LSR	A
	      LSR	A
	      LSR	A
	      ORA	BANK_SW
	      STA	BANK_SW
	      STA	$4046
	      RTS
;-------------------------------------------------------------------------------
CMPF0
	      CMP	#00H
	      BNE	CMPF0_01
	      INC	REG_ADD+1
	      LDA	REG_ADD+1
	      CMP	#F0H
	      BNE	CMPF0_01
	      LDA	#00H
	      STA	REG_ADD
	      LDA	#E0H
	      STA	REG_ADD+1
	      INC	BANK_SW
	      LDA	BANK_SW
	      STA	$4046
CMPF0_01
	      RTS
;-------------------------------------------------------------------------------
CMPF01
	      CMP	#00H
	      BNE	CMPF01_01
	      INC	REG_ADD+1
	      LDA	REG_ADD+1
	      CMP	#F0H
	      BNE	CMPF01_01
	      LDA	#00H
	      STA	REG_ADD
	      LDA	#E0H
	      STA	REG_ADD+1
	      INC	BANK_G
	      LDA	BANK_G
	      STA	$4046
CMPF01_01
	      RTS
;-------------------------------------------------------------------------------
CMPF02
	      CMP	#00H
	      BNE	CMPF02_01
	      INC	REG_ADD+1
	      LDA	REG_ADD+1
	      CMP	#F0H
	      BNE	CMPF02_01
	      LDA	#00H
	      STA	REG_ADD
	      LDA	#E0H
	      STA	REG_ADD+1
	      INC	BANK_M
	      LDA	BANK_M
	      STA	$4046
CMPF02_01
	      RTS
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------------------
VBLANKING
	      PHP
	      PHA
	      TXA
	      PHA
	      TYA
	      PHA


	      LDA	WRSPSW
	      CMP	#01H
	      BNE	V_SP
	      LDA	WRBGSW
	      CMP	#00H
	      BNE	V_SP
	      LDA	#0H
	      STA	$2003H
	      LDA	#5
	      STA	$4014

	      LDA	#00H
	      STA	WRSPSW
V_SP


	      LDA	WRBGSW
	      CMP	#01H
	      BNE	V_01
	      LDA	#00H
	      STA	DMASourceL
	      LDA	#10H
	      STA	DMASourceH
	      LDA	#00H
	      STA	DMADestinationL
	      LDA	#20H
	      STA	DMADestinationH

	      LDA	#7FH
	      STA	DMALengthL
	      LDA	#07H
	      STA	DMALengthH

	      LDA	#11000000b
	      STA	DMAControl

	      LDA	#00H
	      STA	WRBGSW
V_01

	      LDA	BAX
	      STA	$2005
	      LDA	BAY
	      STA	$2005

	      LDA	#01H
	      STA	BLANK_SW


	      PLA
	      TAY
	      PLA
	      TAX
	      PLA
	      PLP
	      RTI
;-------------------------------------------------------------------------------
D_ERROR
  DW	$0F44,$0F46,$0F48,$0F4A,$0F4C,$0F4E,$0F50,$0F52,$0F54,$0F56,$0F58,$0F5A
  DW	$0F64,$0F66,$0F68,$0F6A,$0F6C,$0F6E,$0F70,$0F72,$0F74,$0F76,$0F78,$0F7A
D_UERROR
  DW	$0B60,$0B62,$0B64,$0B66,$0B68,$0B6A,$0B6C,$0B6E,$0B70,$0B72,$0B74,$0B76
  DW	$0F20,$0F22,$0F24,$0F26,$0F28,$0F2A,$0F2C,$0F2E,$0F30,$0F32,$0F34,$0F36
;-------------------------------------------------------------------------------
PROCERROR
	      LDA	KEY1_0
	      CMP	#00H
	      BEQ	?PROCERROR_01
	      JMP	?PROCERROR_S
?PROCERROR_01
	      LDA	KEY2_0
	      CMP	#00H
	      BEQ	?PROCERROR_E
?PROCERROR_S
	      LDA	#00H
	      STA	ERROR_SW

	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_UERROR
	      STA	SOUR_ADD
	      LDA	#>D_UERROR
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#4CH
	      STA	DEST_ADD
	      LDA	#11H
	      STA	DEST_ADD+1

	      LDA	#12
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT
?PROCERROR_E
	      RTS
;-------------------------------------------------------------------------------
INT
	      LDA	$4033
	      LDA	#11111111B
	      STA	SystemIRQMask
	      SEI
	      PLA
	      PLA
	      PLA

	      LDA	#00H
	      STA	BANK_SW
	      STA	$4046
	      LDA	#<D_ERROR
	      STA	SOUR_ADD
	      LDA	#>D_ERROR
	      STA	BANK_ADD
	      STA	SOUR_ADD+1
	      LDA	SOUR_ADD+1
	      AND	#0FH
	      ORA	#E0H
	      STA	SOUR_ADD+1


	      LDA	#4CH
	      STA	DEST_ADD
	      LDA	#11H
	      STA	DEST_ADD+1

	      LDA	#12
	      STA	BGX
	      LDA	#2
	      STA	BGY
	      JSR	WRBG	   ;WRITE PNT

	      LDA	#1
	      STA	ERROR_SW
	      RTS
;-------------------------------------------------------------------------------
	      ORG	FFFAH
	      DW	VBLANKING
	      DW	BEGIN
	      DW	INT
;-------------------------------------------------------------------------------
